
// Fréquence minimale et maximale de représentation dans le plan de Bode
//----------------------------------------------------------------------
fmin_b=0.01;	fmax_b=100.0;

//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	Bode
// Auteur			:	PERRICHON Pierre
// Date				:	22/10/2019
// Sujet			: 	Affichage des fonctions de tranfert dans le plan de Bode
//					:	Appel normal avec des FTBO pour l'application, soit l'emplilement dans SYS_FTBO
// Paramétrage		:	
//						
// Autres données	:	FTBO est la représentation de la fonction de transfert en représentation d'état (A, B, C, D)
//
// Sorties			:	
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------

function Bode()

	global SYS_FTBO FTBO

	//---------------------------- Fréquentiel

	bode(SYS_FTBO,fmin_b,fmax_b)			// Attention, utilisation directe et globale de SYS_FTBO

	CouleurBode()
	
	a=gca();								// Rajoute la légende dans Bode
	legend(a,Tlegend,opt=1,with_box=%f)
	
	PPe_show_margins(FTBO,'bode');
	
endfunction
//-----------------------------------------------------------------------------------------------
function CouleurBode()

	global TColor

	title(TDiagrammeBode(lang))
	title color blue

	//f=gcf();
	f=scf(NumFigureHydroStab);	
	ListAxes=find(f.children.type=="Axes")

	// Phase
	//------

	a=f.children(ListAxes(1))
	nComposant=find(a.children.type=="Compound")
	
	//disp(nComposant, "nComposant")
	
	Composant=a.children(nComposant)	
	//disp(Composant, "Composant")
	
	n=size(Composant.children)
	n=n(1)

	for i=1:n
			Courbe=Composant.children(i)
			Courbe.foreground=TColor(n-i+1)
			//disp(Courbe, "Courbe")
	end
	
	// Magnitude
	//----------
	a=f.children(ListAxes(2))
	nComposant=find(a.children.type=="Compound")
	Composant=a.children(nComposant)
	n=size(Composant.children)
	n=n(1)
	
	for i=1:n
			Courbe=Composant.children(i)
			Courbe.foreground=TColor(n-i+1)
	end
	
endfunction