//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	Calcul_FTB0_FTBF
// Auteur			:	PERRICHON Pierre
// Date				:	22/10/2019
// Sujet			: 	Calcule les fonctions de transfert FTBO et FTBF, la Marge de Gain et de Phase
//					: 	Empile les fonctions de tranferts dans SYS_FTBF et SYS_FTBO si PID=%t pour le cumul des courbes
//					:	SYS_FTBF et SYS_FTBO
//					: 	Reset les listes SYS_FTBF et SYS_FTBO si PID=%f
// Paramétrage		:	
//						
// Autres données	:	Lance l'interface de calcul des paramètres de stabilité du régulateur de vitesse

// Sorties			:	
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function Calcul_FTB0_FTBF()

	global FTBO FTBF sim 
		
	FTBF=ChargeurXcos("FTBF.zcos", "StateSpace", %t)
		
	FTBO=ChargeurXcos("FTBO.zcos", "Laplace", %t)
	
	// Calcul des marges de gains et de phase de FTBO
	//------------------------------------------------
	[MargeGainG,MargeGainF]=g_margin(FTBO)
	[MargePhaseP,MargePhaseF]=p_margin(FTBO)
	
	Print_sim_G_P_Marge(MargeGainG, MargeGainF, MargePhaseP, MargePhaseF)
	
	//mprintf("******************* Marge gain %s\n",sim.GMarge)
	
endfunction



