//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	ChangeLanguage
// Auteur			:	PERRICHON Pierre
// Date				:	17/10/2024
// Sujet			: 	Changement de langue dans HydroStab
// Paramétrage		:	
//						
// Autres données	:	
//
// Sorties			: Menus et affichages dans la langue sélectionnée
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function ChangeLanguage(ilang)

	global lang	

	if ilang<>lang then
			lang=ilang
	end

	setlanguage(TLangue2(lang))						// Charger la langue de l'aide en ligne	
	
	[path,filename,extension]=fileparts(ConfigPAR)	
	HydroStab_Save_cfg(path, filename+extension)	// Enregistrer la langue pour les prochaines sessions
	
	
	clf()											// Effacement de la fenêtre graphisue
	exec(Root+"HydroStab_gui.sce",-1)				// Redessiner la fenêtre graphique en fonction de la langue sélectionnée
	
	Sys_Compute();									// Tracé des fonctions de transfert
		
endfunction	