//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	[IsNumber]=CheckValues(Label)
// Auteur			:	PERRICHON Pierre
// Date				:	14/05/2020
// Sujet			: 	Vérifie si la liste des tags contient bien des nombres flottants positifs au sens Scilab du terme
//					:	
// Paramétrage		:	
//						
// Autres données	:	

// Sorties			:	%t si tous les nombres sont des réels positifs, %f sinon
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function [IsNumber]=CheckValues(Label)

	boolout=%t		// Diagnostic fonction	
	
	[x,lg]=size(Label)	// Nombre d'éléments dans la liste Label

	for i=1:lg
	
		erreur1=%f; erreur2=%f
		
		xTag=FindObj_PPe("tag", Label(i))
		Nom=xTag.Tag
				
		// On remplace les "," par des points s'il y en a
		//-----------------------------------------------	
		xTag.String=strsubst(xTag.String,",",".")		
		SValue=xTag.String
				
		erreur1=~isnum(SValue);
		if ~erreur1 then
							Value=evstr(SValue)		// Conversion string to double
							if Value<0 then erreur2=%t; end
		end
		
		if erreur1 | erreur2 then 
								// Génération d'une box d'erreur
								//------------------------------
								if erreur1 then messerr=msprintf("%s=%s    is not a Scilab number !",Nom,SValue); end
								if erreur2 then messerr=msprintf("%s=%s    ...value must be positive !",Nom,SValue); end
								
								messagebox(messerr, "Run HydroStab", "error","modal")
								
								boolout=%f;
								
								// Rechargement des structures si erreur Opérateur
								//-------------------------------------------------
								Load_Param_IHM()	
								Load_PID_IHM()
		end;
	
	end

	IsNumber=boolout;
		
endfunction
