//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	HydroStab_Load_cfg
// Auteur			:	PERRICHON Pierre
// Date				:	09/05/2020
// Sujet			: 	Restitution du dernier travail dans le répertoire de HydroStab.sce 
// Paramétrage		:	
//						
// Autres données	:	
//
// Sorties			: FileFound=%t si le fichier de configuration existe, %f sinon	
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function FileFound=HydroStab_Load_cfg()

	FileFound_=%f
	
	err2=-100
	
	try

		file_cfg=Root + "HydroStab.cfg"	// Lecture du fichier de configuation HydroStab.fcg
		exec(file_cfg,-1)				// Chargement du fichier HydroStab.cfg

		setlanguage(TLangue2(lang))						// Charger la langue de l'aide en ligne			

		LastWork=ConfigPAR;
		
		[path,fname,extension]=fileparts(LastWork)
	
		// On vérifie que le nom de fichier contient au moins les 2 mots clefs "HydroStab" et ".par"
		//---------------------------------------------------------------------------------------
		tmp1=strstr(fname,"HydroStab")
		tmp2=strstr(LastWork,".par")
	
		if length(tmp1)>0 & extension==".par" then 
					try

						[fd2, err2]=mopen(LastWork)	// On vérifie s'il est possible d'ouvrir le fichier	
						FileFound_= (err2==0)
					catch
					end
		end
	catch
		mprintf(ErrConfig(lang)); mprintf("\n")
		errclear(0)
	end

	if (err2==0) then mclose(fd2); end;
	
	if FileFound_ then
					// Chargement du dernier fichier HydroStab - .PAR
					//--------------------------------------------
					
					FileFound_ = HydroStab_Load(LastWork)						
	end

	if 	~FileFound_ then
						mprintf("%s\n\n",TDef(lang))
						ConfigPAR=SCI_HYDROTUR_HydroStab+TNom_Def+".par"
	end
		
	FileFound=FileFound_	
	
endfunction
