//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	HydroStab_XcrossClosure
// Auteur			:	PERRICHON Pierre
// Date				:	26/08/2020
// Sujet			: 	Fermeture de HydroStab par la croix en haut à gauche de la fenêtre HydroStab 
// Paramétrage		:	
//						
// Autres données	:	Si aucun changement n'est détect dans les FT, fermeture directe de OpsSim
//					:	Sinon, demande d'enregistrement du travail
//					:
//					:	Tsim_Save et TParam_Save sont initialisés à chaque chargement d'un fichier HydroStab ".PAR"
//					:	Si les structures TSim, TParar et Tsim_Save, TParam_Save sont identiques, sortie immédiate
//					:	Sinon, proposition de sauvegarde avant exit
// Sorties			:	
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function [BP]=HydroStab_XcrossClosure(del)

			BP=10;
			
			FigureHydroStab=scf(NumFigureHydroStab);


			// Comparaison des structures multi-faisceaux
			//--------------------------------------------
			d1=%f; d2=%f;
			
			try				
				d1=isequal(Tsim.Kp,Tsim_Save.Kp) & isequal(Tsim.Ti,Tsim_Save.Ti) & isequal(Tsim.Td,Tsim_Save.Td) & isequal(Tsim.Kd,Tsim_Save.Kd)
				d2=isequal(TParam,TParam_Save)		
			catch
					// Nothing
			end

			if ~d1 || ~d2  then
									mes1=TContext1(lang)
									mes2=TContext2(lang)
									
									BP=messagebox([mes1;"";mes2;""], HandleHydroStab, "question", [TQuit(lang) TNon(lang) TOui(lang)], "modal")
									
									if BP==1 then
													// Abandon opérateur, retour HydroStab
													//----------------------------------
													return; 		
									end
									
									if BP==3 then 
													// Demande de sauvegarde de la configuration
													//-------------------------------------------
													HydroStab_Save()
									end
			end
		
		if del then
					delete(FigureHydroStab)				// Fermeture définitive de HydroStab
		else
					clf(hydrostab.figure_id);			// Netoyage de la figure et de tous les handles
		end

endfunction
