//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	PPe_show_margins
// Auteur			:	PERRICHON Pierre
// Date				:	02/10/2019
// Sujet			: 	Trace les marges de gain et de phase dans les plans de Nuquist ou Bode 
// Paramétrage		:	h = fonction de transfert en bloucle ouverte
//					:	
//						
// Autres données	:	

// Sorties			:	
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//-----------------------------------------------------------------------------------------------------------------------
function PPe_show_margins(h,typ)
//return
		global sim

		if argn(2)<2 then 
				typ='bode';
		end
		if and(typ<>['nyquist','bode']) then
            error(msprintf(_("%s: Wrong value for input argument #%d: Must be in the set {%s}.\n"),..
		   "show_margins",2,'""nyquist"", ""bode""'))
		end
  
		drawlater();

		// Marge de gain et Marge de Phase
		//--------------------------------
		//[gm,frgm]=g_margin(h)		
		//[phm,frphm]=p_margin(h)
		
		[gm,frgm]=Read_Marge(sim.GMarge)			
		[phm,frphm]=Read_Marge(sim.PMarge)
			
		if typ=="bode" then
		
	  
				//Marge de gain et de Phase dans le diagramme de Bode)
				//----------------------------------------------------
				//f=gcf();
				f=scf(NumFigureHydroStab)
		
				ListAxes=find(f.children.type=="Axes")				
				axg=f.children(ListAxes(2));		// Axes marge de gain		
				axp=f.children(ListAxes(1));		// Axes marge de phase
								
				fmin=min(axg.x_ticks.locations);
				fmax=max(axg.x_ticks.locations);
				gmin=min(axg.y_ticks.locations);
				gmax=max(axg.y_ticks.locations);
				
				pmin=min(axp.y_ticks.locations);
				pmax=max(axp.y_ticks.locations);
    
				sca(axp);
				if frgm<>[] & frgm>0 then 
							xpoly([fmin;fmax],[-180;-180])
							e=gce();e.foreground=color('blue');e.line_style=4;
				end
		
				if frgm<>[] & frgm>0 then
						// Tracé Marge de gain
						//---------------------
						xpoly([frgm;frgm],[pmin;pmax])
						e=gce();e.foreground=color('blue');e.line_style=4;
						sca(axg);
						xpoly([frgm;frgm],[gmin;gmax])
						e=gce();e.foreground=color('blue');e.line_style=4;
						xpoly([frgm;frgm],[-gm;0])
						e=gce();e.foreground=color('blue');e.thickness=2;
				end
    	
				sca(axg);
				if frphm<>[] then xpoly([fmin;fmax],[0;0])
						e=gce();e.foreground=color('red');e.line_style=4;
				end
	
				if frphm<>[] then
						// Tracé Marge de phase
						//---------------------
						xpoly([frphm;frphm],[gmin;gmax])
						e=gce();e.foreground=color('red');e.line_style=4;
						sca(axp);
						xpoly([frphm;frphm],[pmin;pmax])
						e=gce();e.foreground=color('red');e.line_style=4;
						xpoly([frphm;frphm],[-180;phm-180])
						e=gce();e.foreground=color('red');e.thickness=2;
				end	
			
				drawnow();
			
				return;			//...fin marge de gain et phase dans le plan de Bode
		end

		//Marge de gain et de Phase dans le diagramme de Nyquist
		//-------------------------------------------------------	
		xgrid(color("lightgrey")*ones(1, 2))

		ax=Plotter
		
		xpoly([min(ax.x_ticks.locations);0],[0;0]);
		e=gce();e.foreground=color('magenta');e.line_style=4;

//h=ss2tf(h)		// Retour de l'espace d'état à la fonction de tranfert (Modif PPe 22/10/2019)	
	
		if frgm<>[] then
					// Trace le module de FTBO
					//--------------------------
					if h.dt=='c' then
						f=horner(h,2*%i*%pi*frgm);
					else
						dt=h.dt;
						if dt=='d' then dt=1; end
						f=horner(h,exp(2*%i*%pi*frgm*dt));
					end	
					xpoly([real(f);0],[0;0]); 
					e=gce();e.foreground=color('blue');e.thickness=2;
		end
    
		//Iso cercles
		//-----------
		t=linspace(0,2*%pi,150);		// Fixe le domaine

		//Cercle -3 dB
		//------------
		PlotDB(t,"- 3",'green',0.13);
	
		//Cercle 0 Db
		//------------
		PlotDB(t,"  0",'red',0.1);	
	
		// Cercle 3 dB
		//------------
		PlotDB(t,"  3",'green',0.1);
	
		// Cercle 6 dB
		//------------
		//PlotDB(t,"  6",'green',0.1);
		
		//Dessiner le Point Critique
		//--------------------------	
		rP=0.015;
		xcolor=color("red")
		xfpoly(-1+rP*sin(t),rP*cos(t),xcolor);
		e=gce();e.foreground=xcolor;e.line_style=1;

		// Cercle de rayon ma
		//-------------------
		r=ma;
		xpoly(-1+r*sin(t),r*cos(t));
		e=gce();e.foreground=color('magenta');e.line_style=1;		
	
		//Dessiner le point P
		//---------------------
		xpoly([-1;0],[0;-1]);	//Droite angle -pi/4
		e=gce();e.foreground=color('magenta');e.line_style=1;
		
		x=-1+sin(%pi/4)*r;y=0-cos(-%pi/4)*r;			// Placement du point P		
		x2=x+rP*sin(t);y2=y+rP*cos(t)
		xcolor=color("magenta")
		xfpoly(x2,y2,xcolor);
		e=gce();e.foreground=xcolor;e.line_style=1;
	
		str = string("P")  ;							// Placement de la lettre P
		//xstring( x-0.05, y+0.05, str ) ;	
		xstring( x-0.0, y+0.05, str ) ;	
		e=gce();
		e.font_foreground=color('magenta');e.font_size=3;e.font_style=8

		if frphm<>[] then
				// Dessiner la marge de phase
				//---------------------------
				t=phm*%pi/180+%pi;
				xpoly([cos(t);0],[sin(t);0])
				e=gce();e.foreground=color('red');e.thickness=2;
		end
		
	
		drawnow();
		
endfunction

