//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	Plot_Max_Reglin
// Auteur			:	PERRICHON Pierre
// Date				:	19/09/2020
// Sujet			: 	Rajoute sur le scope ZN :
//					: 		- Le tracé des maximus locaux	
//					: 		- La droite de régression linéaire au sens des moindres carrés, passant par ces points de pente "Pente"
//					: 	Calcule le temps moyen des oscillation Tosc
//					: 	
//					:	
//------------------------------------------------------------------------------------------------------------------------
function [Tosc, Pente, Ecart]=Plot_Max_Reglin(Kcr)

	global T_max V_max Rep_ZN

	// Mesure la période des oscillations
	//-----------------------------------	
	f=scf(NumFigureZN)
	
	time=Rep_ZN.time
	val=Rep_ZN.values

	[x,nbpoint]=size(val)

	Tosc=0; Pente=-1.e-10; Ecart=0.;
	T_max=[];V_max=[]
	k=1
	
	v=val(1)
	vz=v
	
	mode=1		// mode=1 sens croissant - mode=-1 sens décroissant

	for i=1:nbpoint
	
		v=val(i)
		
		if v<=0 then continue; end
		
		if mode==1 then
						// Sens croissant
						//---------------
						if v<vz then 
							T_max(k)=time(i-1)
							V_max(k)=val(i-1)
							k=k+1
							mode=-1
						end
						vz=v
		else
						// Sens décroissant
						//-----------------
						if v>vz then  mode=1; end
						vz=v;
		end
				
	end
	
	lg=size(T_max,"*")	
	
	if lg<3 then
				drawnow();
				return
	end
	
	// On élimine le premier échantillon
	//----------------------------------
	T_max=T_max(2:k-1)
	V_max=V_max(2:k-1)
	
	lg=size(T_max,"*")	
	
	T_Tosc=[]
	
	xx=[]
	
	for i=1:lg-1	
				T_Tosc(i)=T_max(i+1)-T_max(i)
	end
	
	// Période moyenne
	//----------------
	Tosc=mean(T_Tosc)
	
	// Ecart premier-dernier point
	//----------------------------
	Ecart=V_max(1)-V_max(lg)
	
	// Echelle du scope
	//-----------------
	xmin=0; xmax=TSimZN					// TSimZN est défini dans le fichier HydroStab.PAR
	ymin=min(val); ymin=(ymin*10-1)/10; 
	ymax=max(val); ymax=(ymax*10+1)/10
		
	drawlater()

	// Tracé des maxi avec points ou datatips suivant option ZN_Datatip
	//-----------------------------------------------------------------
	if ~ Auto_ZN then 
	
		plot(T_max,V_max,"b*")
	
		e=gce() 
		p=e.children(1)
	
		p.mark_mode="on";p.mark_style=0;p.mark_size=5;

	
		if ZN_Datatip then
					// Affichage des datatips. ZN_Datatip est programmable dans "HydroStab.par"
					//--------------------------------------------------------------------------
					for i=1:lg
								t=T_max(i)
								v=V_max(i)
								tip=datatipCreate(p,[t,v]);
								datatipSetOrientation(tip,"lower left")
					end
		end
		
	end

	// Tracé de la droite de régression linéaire au sens des moindres carrés des maximum
	//-----------------------------------------------------------------------------------
	xx=T_max'
	yy=V_max'
	[a,b,residu]=reglin(xx,yy)
	
	Pente=a
	
	if ~ Auto_ZN then plot(xx,a*xx+b,"-b"); end
	
	ZN_Grille()
	
	replot([xmin, ymin, xmax, ymax])
	
	drawnow()

endfunction
