//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	PrintScilabConsole(index)
// Auteur			:	PERRICHON Pierre
// Date				:	05/08/2021
// Sujet			: 	Print des FT dans la console Scilab
//					:	
// Paramétrage		:	index=-1 ou 0  : impression de toute les FT
//                  :   si index > 0 inpression FT(index) uniquement 
//						
// Autres données	:	
//					!	
//					:	
//					:	
//
// Sorties			:	
//					:	
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function PrintScilabConsole(index)

	select ModeSim
	
		case 0 then
					fct="Nyquist - FTBO"
		case 1 then
					fct="Bode - FTBO"
		else
					fct=msprintf("%s - FTBF",TIndiciel(lang))
	end

	// Obtenir les date et heure pour impression
	//------------------------------------------
	mprintf("\n")
	xclock=clock();
	txtdate=msprintf("%02i/%02i/%04i - %02i:%02i:%02i",xclock(3),xclock(2),xclock(1),xclock(4),xclock(5),xclock(6))	
	
	mprintf("--- %s -------------------------------------------------------------------- %s\n",txtdate,fct)
	

	if index<=0 then	
				// Impression console Scilab
				//--------------------------
				[lg,x]=size(Tsim)		
	
				for i=1:lg
						mprintf("FT%i : \t %s - \t%s\n",i, TParam(i).Id, TParam(i).Comment)
						mprintf("\t Kp=%0.2f Ti=%0.2f s Td=%0.2f s Kd=%0.2f\n", Tsim(i).Kp, Tsim(i).Ti, Tsim(i).Td,Tsim(i).Kd);
						mprintf(TMarge_Gain_Phase(lang),Tsim(i).GMarge,Tsim(i).PMarge)
				end	
	else
				i=index
				mprintf("FT%i : \t %s\n",i, TParam(i).Comment)
				mprintf("\t Kp=%0.2f Ti=%0.2f s Td=%0.2f s Kd=%0.2f\n", Tsim(i).Kp, Tsim(i).Ti, Tsim(i).Td,Tsim(i).Kd);
				mprintf(TMarge_Gain_Phase(lang),Tsim(i).GMarge,Tsim(i).PMarge)
	end
	
endfunction
