//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	Sys_DEL
// Auteur			:	PERRICHON Pierre
// Date				:	18/08/2020
// Sujet			: 	Supression d'une fonction de transfert dans l'interface HydroStab
//					:	
// Paramétrage		:	
//						
// Autres données	:	
//					:	
//					:	
//
// Sorties			:	La FT indiquée est supprimée après demande de confirmation.
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function Sys_DEL()

	global Tsim TParam
	
	[i_FT,nb_FT]=FT_Select_GUI()
	
	if i_FT==0 then return; end			// Abandon opérateur
	
	
	// Demande de confirmation
	//------------------------	
	mes=msprintf("%s FT%i ?", TSupprimer(lang), i_FT)
	[BP]=messagebox(mes, "Sys_DEL", "question", [TNon(lang) TOui(lang)], "modal")

	if BP==1 then return; end			// Abandon opérateur
	
	Tsim_Copy=[]
	TParam_Copy=[]
	
	k=1
	
	for i=1:nb_FT
			
			if i==i_FT then continue; end
			
			Tsim_Copy(k)=Tsim(i)
			TParam_Copy(k)=TParam(i)
			
			k=k+1		
			
	end
	
	// Nouvelle construction
	//----------------------
	Tsim=Tsim_Copy
	TParam=TParam_Copy
	 
	File=HydroStab_Save(%t)			// Sauvegarder la nouvelle configuration dans un fichier temporaire au format HydroStab

	HydroStab_Load(File,%t)			// Recharger ce fichier	(%t signifie mode DEL) - En particulier HydroStab_Load reconstruit SYS_FTBO et SYS_FTBF à partir du fichier temporaire
	
	deletefile(File)				// Détruire le fichier temporaire

endfunction
