//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	ZN
// Auteur			:	PERRICHON Pierre
// Date				:	22/10/2019
// Sujet			: 	Calcul les paramètres de réglage Kp; Ti, Td du régulateur de vitesse d'éprès la théorie de Ziegler et Nichols
//					: 	par le méthode de Limite de pompage
//					:	
// Paramétrage		:	Kcr	 = gain au pompage
//					:	Tosc = période de pompage
//					:	
// Autres données	:	
//					:
// Sorties			:	Kp, Ti, Td. Ces données sont affichées sur la console
//					:			
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function [Kp, Ti, Td, Kd]=ZN(Kcr,Tosc)

	global Gradient_Methode

	select Gradient_Methode
					
		case 1 then
					// Réglage Ziegler-Nichols PPe
					//-----------------------------------
					Kp=0.6*Kcr			// Gain proportionnel
					Ti=Tosc/2			// Constante de temps de l'intégrale
					Td=Tosc/10			// Constantde de temps du dérivateur	
					Kd=10
					
		case 2 then
					// Réglage Takahashi
					//-----------------------------------
					dt=dt_Ech
					
					//Ki=1.2*Kcr*dt/Tosc				// Constante de temps de l'intégrale
					//Ti=1/Ki
					
					//Kp=0.6*Kcr-0.5*Ki					// Gain proportionnel
					
					//Kd=3*Kcr*Tosc/(40*dt)
					//Td=1/Kd			// Constantde de temps du dérivateur	
					
					Kp=0.6*(1-dt/Tosc)*Kcr
					Ti=0.5*(Tosc-dt)
					Td=Tosc^2/(8*Tosc-dt)
					Kd=4					
	end

	// Imprimer les résultats sur la console
	//--------------------------------------
	mprintf("\n\n---------------------------------------------------------------------------------------\n")
	
	if Gradient_Methode==1 then mprintf("%s\n",TGradient_Methode1(lang)); end
	if Gradient_Methode==2 then mprintf("%s\n",TGradient_Methode2(lang)); end
	
	mprintf("%s%i\n",TMethod(lang), Gradient_Methode)
	
	mprintf("---------------------------------------------------------------------------------------\n")
	
	mprintf("%s Kcr=%0.3f\n%s Tosc=%0.3f\n\n",TKcr(lang),Kcr,TTosc(lang),Tosc)
	mprintf("%s Kp=%0.2f\n%s Ti=%0.2f\n%s Td=%0.2f\n",TKp(lang), Kp, TTi(lang), Ti, TTd(lang), Td);
	mprintf("\n");
					
endfunction

