//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	ZN_GUI_1
// Auteur			:	PERRICHON Pierre
// Date				:	19/09/2020
// Sujet			: 	Calcul de Tosc
//					: 	Calcul des paramètres Kp, Ti, Td en fonction de Kcr et ToscRetoune le numéro de la fenêtre graphique Ziegler-Nichols
//					:	
//-------------------------------------------------------------------------------------------------------------------------------------------
function [BP, valid]=ZN_GUI_1(Kcr, Tosc, Pente, Ecart)

	global sim Param Gradient_Methode

	valid=%f	
	
	// Calcul du PID
	//--------------	
	[Kp, Ti, Td, Kd]=ZN(Kcr,Tosc)		

	// Affichage des résultats
	//------------------------
	
	Txt_MethodeZN=msprintf("%s %i", TMethod(lang), Gradient_Methode)
	
	Txt_Kcr=msprintf("%s=%0.3f", TxZN1(lang), Kcr)
	Txt_Tosc=msprintf("%s=%0.3f", TxZN2(lang), Tosc)
	
	Txt_RegLin=msprintf("%s %0.2e", TxZN3(lang), Pente)
	Txt_Ecart=msprintf("%s=%0.7f", TxZN4(lang), Ecart)

	Txt_Kp=msprintf("%s Kp=%0.2f", TxZN5(lang), Kp)
	Txt_Ti=msprintf("%s Ti=%0.2f",TxZN6(lang), Ti)
	Txt_Td=msprintf("%s Td=%0.2f",TxZN7(lang), Td)
	Txt_Kd=msprintf("%s Kd=%0.2f",TxZN8(lang), Kd)

	// Interface opérateur
	//--------------------
    BP = messagebox( (["";
	Txt_MethodeZN;
	"";
    Txt_Kcr;
    Txt_Tosc;
	"";
	Txt_RegLin;
	Txt_Ecart;
	""
	Txt_Kp;
	Txt_Ti;
	Txt_Td;
	Txt_Kd;
    ".";]),...
	TitreZN, "info", ([ TAuto(lang) "Kcr" TValid(lang) TQuit(lang) ]), "modal");
	
	if BP==3 then
					// Validation et retour à HydroStab
					//----------------------------------
					sim.Kp=Kp
					sim.Ti=Ti
					sim.Td=Td
					sim.Kd=Kd

	
					select Gradient_Methode					
						case 1 	
								Param.Comment="Ziegler-Nichols"
						case 2 	
								Param.Comment="Takahaschi"
						else	
								Param.Comment="...Autre méthode"
					end
					
					valid=%t
					
	end
		
endfunction