//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	ZN_Optimize
// Auteur			:	PERRICHON Pierre
// Date				:	12/05/2022
// Sujet			: 	Recherche automatique du pas de progression dans la méthone ZN
//					: 	
//					:	
//------------------------------------------------------------------------------------------------------------------------
function [Kcr, Auto_ZN]=ZN_Optimize(Kcr, Pente, Ecart)

	global M_Kcr M_Pente iter_ZN i_incr_Kcr V_max T_max

	// Table des incréments du gain critique Kcr
	//------------------------------------------
	T_incr_Kcr=[0.2, 0.1, 0.05, 0.01, 0.005, 0.001]

	Auto_ZN=%t
	
	
	if iter_ZN==1 then
						f=scf(NumFigureZN)
						f.info_message=TOptimsation(lang)
						
						i_incr_Kcr=1
						
						[len,xxx]=size(V_max)
						if len>2 && abs(V_max(1)-V_max(len))<0.005 && V_max>A_Ech*1.05 then i_incr_Kcr=4; end
						
						M_Pente=Pente
	end	

	if Trace_ZN then
					mprintf("Itération=%02i Kcr=%0.3f M_Kcr=%03f Pente=%10.07f M_Pente=%10.07f Ecart=%10.7f Incrément=%0.4f\n",iter_ZN, Kcr, M_Kcr, Pente, M_Pente, Ecart, T_incr_Kcr(i_incr_Kcr))  
	end
	
	// Détection de changement de pente
	//---------------------------------	
	if sign(Pente)==sign(M_Pente) then
												// On continue avec le même increment
												//-----------------------------------
												M_Pente=Pente
												M_Kcr=Kcr
												Kcr=Kcr+T_incr_Kcr(i_incr_Kcr)*sign(-Pente)
	else
		// Changement de pente détecté
		//----------------------------
		[xxx, len]= size(T_incr_Kcr)
		if i_incr_Kcr>=len then
							// Fin de la recherche
							//--------------------
							//pause()					// Supprime le commentaire "//" pour pouvoir prendre la photo du parcours
							f=scf(NumFigureZN)
							f.info_message=""
							
							Auto_ZN=%f
							return
		end
	
		i_incr_Kcr=i_incr_Kcr+1					// On baisse l'incrément
		Kcr=M_Kcr+T_incr_Kcr(i_incr_Kcr)*sign(-M_Pente)
	
	end
	
	iter_ZN=iter_ZN+1

endfunction
