//------------------------------------------------------------------------------------------------------------------------
// Procédure		:	isSite
// Auteur			:	PERRICHON Pierre
// Date				:	27/08/2020
// Sujet			: 	Filtrage des caractères du nom du site
//					;	Raison : Actuellement, il n'est pas possible sous Scilab d'enregistrer des fichiers "scg"
//					:	contenant des lettres accentuées, pour Scilab 5.5.2 et 6.1.0 
// 					:	Dommaine d'acceptation:
//					:
// Paramétrage		:	
//					:	
// Autres données	:	Si titre rejeté, affichage d'un message d'erreur jusqu'à correction opérateur.
//					:	
//
// Sorties			:	
//						
// Modifications	:
//-------------------
// Auteur			:	
// Date				:	
// Description		:	
//
//------------------------------------------------------------------------------------------------------------------------
function [succes]=isSite()

	succes=%t;
	
	try
	
		Site = FindObj_PPe("tag", "Site")			
		NomSite=Site.String
		
		for i=1:length(NomSite)
				c=part(NomSite,i)
				code=ascii(c)
	
				// Filtrage des caractères accentués
				//-----------------------------------
				[x,y]=size(code)
				if y>1 then succes=%f; break; end
	
				// Filtrage des caractères ASCII en décimal, acceptés (signes - ou _ ou Space + Chiffre + Alphbat majuscule ou minuscule)
				//---------------------------------------------------------------------------------------------------------------------------
				if code==32 | code==45 | code==95 | (code>=48 & code<=57) | (code>=65 & code<=90) | (code>=97 & code<=122) then continue; end
	 
				succes=%f	// Echec ==> abandon
				break
		end

		
	catch	
		lasterror()
	end
	
	if ~succes then 
					Site.String=strncpy(NomSite,i-1)

					message=msprintf(TAccent(lang))
					messagebox(message, HandleHydroStab, "warning","modal")
					
					Site.String=Param.Id		// Restitution de l'Id avant modification					

	end
			
endfunction

